/* =========================================================================
	This library is part of IshiSoft CEHTTP base class.
	------------------------------------------------------------------------
	author: yu-ishi@ya2.so-net.ne.jp
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_)
#define AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define PDELETE(p)	{if(p) delete p;p=NULL;}


#define MAX_CHAR	64

// ---------------------------------------------- Server name
#define	MYCONF_WSTR_KEY_SRVNAME	L"ServerSoftware"
#if defined(DEBUG)||defined(_DEBUG)
#define	MYCONF_STR_SRVNAME		"CEHTTP/2.34[DEBUG]"
#else
#define	MYCONF_STR_SRVNAME		"CEHTTP/2.34"
#endif

// ---------------------------------------------- document root
#define MYCONF_WSTR_KEY_DOCROOT	L"DocRoot"
#define	MYCONF_STR_DOCROOT		"\\wwwroot"

// ---------------------------------------------- script root
#define MYCONF_WSTR_KEY_CGIROOT	L"CgiRoot"
#define	MYCONF_STR_CGIROOT		"\\wwwroot\\scripts"

// ---------------------------------------------- default page
#define MYCONF_WSTR_KEY_DEFPAGE	L"DefaultDoc"
#define	MYCONF_STR_DEFPAGE		"index.html"

// ---------------------------------------------- basic.cha
#define MYCONF_WSTR_KEY_BAUTHFILE	L"BasicAuthFile"
#define MYCONF_STR_BAUTHFILE	"access.cha"

// ---------------------------------------------- filter
#define MYCONF_WSTR_KEY_MODULE	L"Filter"
#define MYCONF_STR_MODULE		"cehin.fil"

// ---------------------------------------------- LogFiles
#define MYCONF_WSTR_KEY_LOGFILE	L"LogFile"
#define MYCONF_STR_LOGFILE		"\\access_log.txt"

#define MYCONF_WSTR_KEY_LOGSIZE	L"LogSize"
#define MYCONF_NUM_LOGSIZE		102400

// ---------------------------------------------- listen port
#define MYCONF_WSTR_KEY_PORT	TEXT("Port")
#define MYCONF_NUM_PORT			80

// ---------------------------------------------- timeout for transaction
#define MYCONF_WSTR_KEY_TIMEOUT	TEXT("Timeout")
#define MYCONF_NUM_TIMEOUT		3000

// ---------------------------------------------- KEEPALIVE
#define MYCONF_WSTR_KEY_KEEPALIVE	TEXT("KeepAlive")
#define MYCONF_NUM_KEEPALIVE	1

// ---------------------------------------------- StartServers
#define MYCONF_WSTR_KEY_SERVERS	TEXT("StartServers")
#define MYCONF_NUM_SERVERS		8

// ---------------------------------------------- DnsLookup
#define MYCONF_WSTR_KEY_DNSLOOKUP	L"DNSLookup"
#define MYCONF_NUM_DNSLOOKUP		0



#define MYCONF_WSTR_SUBKEY	TEXT("SOFTWARE\\ISHISOFT\\CEHTTP")

class MyConf  
{
public:
	MyConf();
	virtual ~MyConf();
	char*	m_pszServerSoftware;			// = "Ishisoft-CEHTTP/x.x";
	char*	m_pszDocRootName;				// = "\\wwwroot";
	char*	m_pszCgiRootName;				// = "\\wwwroot\\scripts";
											// 
	char*	m_pszDefaultDocName;			// = "index.html";
	char*	m_pszAccessFileName;			// = "access.cha"
	char*	m_pszLogFile;					// = "access_log.txt"
	int		m_nLogSize;						// = 102400
	int		m_nListenPort;					//	= 80;
	int		m_nStartServers;				//	= 8;
	int		m_nTimeOut;						// = 3000;
	int		m_nKeepAlive;					// = 1(ON)
	int		m_nDNSLookup;					// = 0;

	LONG ReadTStringValue(TCHAR* tszKey, TCHAR* tszValue, int nValueSize);
	void ReadNumericValue(TCHAR* tszKey, DWORD* pdwValue, DWORD dwDefaultValue);
	void ReadNumericValue(TCHAR* tszKey, int* pdwValue, int dwDefaultValue);
	int ReadStringValue(TCHAR* tszKey, char* szValue, int nValueSieze, char* szDefaultValue);
	BOOL WriteStringValue(TCHAR* tszKey, TCHAR* tszValue);
	BOOL WriteStringValue(TCHAR* tszKey, char* szValue);
	BOOL WriteIntValue(TCHAR* tszKey, int nNumber);

};

#endif // !defined(AFX_MYCONF_H__B9FC4FB9_9FCE_4BE3_92AA_8DE46CDB8436__INCLUDED_)
